<?php

// uncomment the following to define a path alias
// Yii::setPathOfAlias('local','path/to/local-folder');

// This is the main Web application configuration. Any writable
// CWebApplication properties can be configured here.
return array(
	'basePath'=>dirname(__FILE__).DIRECTORY_SEPARATOR.'..',
	'name'=>'My Web Application',
	'sourceLanguage' => 'en',
  	'language' => 'ru',

	// preloading 'log' component
	'preload'=>array('log'),

	// autoloading model and component classes
	'import'=>array(
		'application.models.*',
		'application.components.*',
		'application.modules.user.models.*',
    	'application.modules.user.components.*',
    	'application.modules.rights.*',
  		'application.modules.rights.models.*',
  		'application.modules.rights.components.*',
  		'ext.eoauth.*',
        'ext.eoauth.lib.*',
        'ext.lightopenid.*',
        'ext.eauth.*',
        'ext.eauth.services.*',
	),

	'modules'=>array(
		// uncomment the following to enable the Gii tool
		/*
		'gii'=>array(
			'class'=>'system.gii.GiiModule',
			'password'=>'Enter Your Password Here',
			// If removed, Gii defaults to localhost only. Edit carefully to taste.
			'ipFilters'=>array('127.0.0.1','::1'),
		),
		*/
		'user',
    	'rights',
	),

	// application components
	'components'=>array(
		'user'=>array(
			// enable cookie-based authentication
			'allowAutoLogin'=>true,
			'class' => 'RWebUser',
		),
		'authManager'=>array(
    		'class'=>'RDbAuthManager',
    		'defaultRoles' => array('Guest,ServiceAuth'),
  		),
		// uncomment the following to enable URLs in path-format
		/*
		'urlManager'=>array(
			'urlFormat'=>'path',
			'rules'=>array(
				'<controller:\w+>/<id:\d+>'=>'<controller>/view',
				'<controller:\w+>/<action:\w+>/<id:\d+>'=>'<controller>/<action>',
				'<controller:\w+>/<action:\w+>'=>'<controller>/<action>',
			),
		),
		/*
		'db'=>array(
			'connectionString' => 'sqlite:'.dirname(__FILE__).'/../data/testdrive.db',
		),
		// uncomment the following to use a MySQL database
		*/
		'db'=>array(
			'connectionString' => 'mysql:host=localhost;dbname=eauth',
			'emulatePrepare' => true,
			'username' => 'root',
			'password' => '',
			'charset' => 'utf8',
			'tablePrefix' => 'tbl_',
		),
		
		'errorHandler'=>array(
			// use 'site/error' action to display errors
			'errorAction'=>'site/error',
		),
		'log'=>array(
			'class'=>'CLogRouter',
			'routes'=>array(
				array(
					'class'=>'CFileLogRoute',
					'levels'=>'error, warning',
				),
				// uncomment the following to show log messages on web pages
				/*
				array(
					'class'=>'CWebLogRoute',
				),
				*/
			),
		),
		'loid' => array(
        'class' => 'application.extensions.lightopenid.loid',
    ),
    'eauth' => array(
        'class' => 'ext.eauth.EAuth',
        // Использовать всплывающее окно вместро перенаправления.
        'popup' => true,
        // Имя компонента кэширования или false для отключения. По умолчанию 'cache'.
        'cache' => false,
        // Время жизни кэша. 0 значит нограничено.
        'cacheExpire' => 0,
        // Провайдеры
        'services' => array(
            'yandex_oauth' => array(
            // register your app here: https://oauth.yandex.ru/client/my
                'class' => 'YandexOAuthService',
                'client_id' => '',
                'client_secret' => '',
                'title' => 'Yandex (OAuth)',
            ),
            'google_oauth' => array(
            // register your app here: https://code.google.com/apis/console/
                'class' => 'GoogleOAuthService',
                'client_id' => '...',
                'client_secret' => '...',
                'title' => 'Google (OAuth)',
            ),
            'vkontakte' => array(
            // register your app here: https://vk.com/editapp?act=create&site=1
                'class' => 'VKontakteOAuthService',
                'client_id' => '',
                'client_secret' => '',
            ),
        ),
    ),
	),

	// application-level parameters that can be accessed
	// using Yii::app()->params['paramName']
	'params'=>array(
		// this is used in contact page
		'adminEmail'=>'webmaster@example.com',
	),
);